#ifndef _LINUX_INOTIFY_H
#define _LINUX_INOTIFY_H

#include <linux/types.h>

/* Inotify event */
struct inotify_event {
	__s32	wd;
	__u32	mask;
	__u32	cookie;
	__u32 	len;
	char name[0];
};

/* Inotify request */
struct inotify_watch_request {
	int		fd;
	__u32	mask;
};

/* Inotify events */
#define IN_ACCESS			0x00000001
#define	IN_MODIFY			0x00000002
#define	IN_ATTRIB			0x00000004
#define	IN_CLOSE_WRITE		0x00000008
#define	IN_CLOSE_NOWRITE	0x00000010
#define IN_OPEN				0x00000020
#define	IN_MOVED_FROM		0x00000040
#define	IN_MOVED_TO			0x00000080
#define IN_DELETE_SUBDIR	0x00000100
#define	IN_DELETE_FILE		0x00000200
#define IN_CREATE_SUBDIR	0x00000400
#define	IN_CREATE_FILE		0x00000800
#define	IN_DELETE_SELF		0x00001000
#define	IN_UNMOUNT			0x00002000
#define	IN_Q_OVERFLOW		0x00004000
#define IN_IGNORED			0x00008000

#define	IN_ALL_EVENTS		0xFFFFFFFF
#define IN_CLOSE			(IN_CLOSE_WRITE|IN_CLOSE_NOWRITE)

#define	INOTIFY_IOCTL_MAGIC	'Q'
#define	INOTIFY_IOCTL_MAXNR	2

#define INOTIFY_WATCH 		_IOR(INOTIFY_IOCTL_MAGIC, 1, struct inotify_watch_request)
#define INOTIFY_IGNORE      _IOR(INOTIFY_IOCTL_MAGIC, 2, int)

#endif
